<template>
  <section class="security-level">
    <label class="label">Niveau de sécurité</label>
    <div class="progresse-bar" :class="codeCss">
      <span class="progress-bar-details" :style="'--size :' + size"></span>
    </div>

    <ul v-for="(rule, index) in rules" :key="index" class="rules">
      <mt-security-rules :password="password" :rule="rule"></mt-security-rules>
    </ul>
  </section>
</template>

<script>
import MtSecurityRules from '~/components/connexion/password-security-meter-rules';

export default {
  components: {
    MtSecurityRules,
  },
  props: {
    password: {
      type: String,
      default: null,
    },
    rules: {
      type: Array,
      default() {
        return [];
      },
    },
  },
  data() {
    return {
      size: 0,
    };
  },
  computed: {
    codeCss() {
      let css = 'fort';
      if (this.size <= 30) {
        css = 'faible';
      } else if (this.size <= 70) {
        css = 'moyen';
      }
      return css;
    },
  },
  watch: {
    rules: {
      handler() {
        this.size = 0;
        this.rules.forEach((rule) => {
          if (rule.valid === true) {
            this.size += 100 / this.rules.length;
          }
        });
      },
      deep: true,
      immediate: true,
    },
  },
};
</script>

<style scoped lang="scss">
.faible {
  --rules-item-color: var(--rules-faible);
}

.moyen {
  --rules-item-color: var(--rules-moyen);
}

.fort {
  --rules-item-color: var(--rules-fort);
}

.security-level {
  --rules-faible: #db2c66;
  --rules-moyen: #ffaa00;
  --rules-fort: #51f0b0;

  .progresse-bar {
    background-color: #e9e9e9;
    height: 0.4rem;
    border-radius: 0.4rem;
    margin: 0.8rem 0;
    display: flex;
    overflow: hidden;

    .progress-bar-details {
      flex-basis: calc(var(--size) * 1%);
      transform-origin: left;
      background-color: var(--rules-item-color);
      border-radius: 0.4rem;
      transition-property: flex-basis, background-color;
      transition-duration: 0.5s;
      transition-timing-function: ease-in-out;
    }
  }
}
</style>
